#!/usr/bin/env python

import re
from collections import OrderedDict

### closes
def read_gtfLines(infile_fasta_fn):
    linesTMP = open(infile_fasta_fn, "r")
    lines = list(linesTMP)
    linesTMP.close()
    recordsFN = []
    for line in lines:
        line = line.rstrip("\n")
        elements = line.split("\t")
        geneID = elements[0]
        chrom = elements[1]
        strand = elements[2]
        txStart = elements[3]
        txEnd = elements[4]
        name2 = elements[5]
        #print(elements)
        recordsFN.append([geneID, chrom, strand, txStart, txEnd, name2])
    return recordsFN

def TSSlisting_gtfLines(rec_lists):
    rec_lists2 = []
    for rec_list in rec_lists:
        geneID = rec_list[0]
        chrom = rec_list[1]
        strand = rec_list[2]
        txStart = rec_list[3]
        txEnd = rec_list[4]
        name2 = rec_list[5]
        if strand == "+":
            #                                                                TSS
            rec_lists2.append([geneID, chrom, strand, txStart, txEnd, name2, txStart])
        else:
            rec_lists2.append([geneID, chrom, strand, txStart, txEnd, name2, txEnd])
    return rec_lists2
    
def filter_chr(chr_fasta, recordsFN):
    recordsTMP = []
    for recordFN in recordsFN:
        chrom_gtf = recordFN[1]
        if chrom_gtf == chr_fasta:
            recordsTMP.append(recordFN)
    return recordsTMP

def calculateAbsoluteDistance(CNS_start_FN, rec_chrom_listsFN):
    recordsTMP = []
    for record in rec_chrom_listsFN:
        geneID = record[0]
        chrom = record[1]
        strand = record[2]
        txStart = record[3]
        txEnd = record[4]
        name2 = record[5]
        TSS = record[6]
        distance = abs(int(CNS_start_FN) - int(TSS))
        recordsTMP.append([geneID, chrom, strand, txStart, txEnd, name2, TSS, distance])
    return recordsTMP

def readFasta_dict(infile_fasta_fn):
    Infile = open(infile_fasta_fn, "r")
    seqDictFN  = OrderedDict()
    for Line in Infile:
        Line = Line.rstrip("\n")
        if Line[0] == ">":
            Name            = Line
            seqDictFN[Name] = ""
        else:
            seqDictFN[Name] += Line
    Infile.close()
    return seqDictFN


######## Main program
infile_gtf = "UCSC.test.gtf"

rec_lists = read_gtfLines(infile_gtf)
rec_lists = TSSlisting_gtfLines(rec_lists)
#for rec in rec_lists:
#    print(rec)
#exit()

infaile_fasta = "fastafile.txt"

seqDict = readFasta_dict(infaile_fasta)

count = 0
out = open("out.txt", "w")
for name, seq in seqDict.items():
    count += 1
    match = re.search(">([^:]+):(\d+)\-", name)
    CNS_chrName = match.group(1)
    CNS_start = match.group(2)
    #print("CNS_chrName", CNS_chrName)
    #print("CNS_start", CNS_start)
    rec_chrom_lists = filter_chr(CNS_chrName, rec_lists)
    rec_chrom_lists = calculateAbsoluteDistance(CNS_start, rec_chrom_lists)
    rec_chrom_lists = sorted(rec_chrom_lists, key=lambda x: x[7])

    '''
    for rec in rec_chrom_lists:
        print(rec)
    print(name)
    print(rec_chrom_lists[0])
    print(seq)
    print()
    '''

    #'''
    #print(count, name)
    print(count)
    if rec_chrom_lists:
        neabyGeneName = rec_chrom_lists[0][5]
        neabyGeneName = re.sub(":", "-", neabyGeneName.upper())
    else:
        neabyGeneName = "NONE"
    name += "_" + neabyGeneName
    out.write(name + "\n")
    out.write(seq + "\n")
    #'''

out.close()
